SetFactory("OpenCASCADE");
If(GMSH_MAJOR_VERSION!=3 || GMSH_MINOR_VERSION!=0 || GMSH_PATCH_VERSION!=6)
  Printf("gmsh %g.%g.%g is not supported by this .geo",GMSH_MAJOR_VERSION,GMSH_MINOR_VERSION,GMSH_PATCH_VERSION);
Else
  LX = 10;
  LY = 10;
  LZ = 1;

  nX = 15;
  nY = 15;
  nZ = 1;

  Point(1)  = { 0.,  0., 0.,     lc};
  Point(2)  = { 0.,  LY, 0.,     lc};
  Point(3)  = { LX,  LY, 0.,     lc};
  Point(4)  = { LX,  0., 0.,     lc};

  Line(1) = {1, 2};
  Line(2) = {2, 3};
  Line(3) = {3, 4};
  Line(4) = {4, 1};

  Transfinite Line {1, 3} = nY Using Progression 1;
  Transfinite Line {2, 4} = nX Using Progression 1;

  Line Loop(5) = {1, 2, 3, 4};
  Plane Surface(5) = {5};
  Transfinite Surface {5};
  Recombine Surface {5};

  Extrude {0, 0, LZ}
  {
    Surface{5}; Layers{nZ}; Recombine;
  }

  Physical Volume("body") = {1};

  Physical Surface("load 1") = {7};
  Physical Surface("load 2") = {9};
  Physical Point("clamped xyz") = {1};
  Physical Point("clamped xy") = {5};
  Physical Point("clamped y") = {4};
EndIf
