#!/usr/bin/env python3
# -*- coding: utf-8; -*-



from katoptron.speedup import *


def speedup_of_one_case(case_id, n_samples, ensemble_sizes, quantiles,
                        querylines, use_waves_timers, use_teuchos_timers,
                        per_iteration):
    import matplotlib.pyplot as plt

    case_id = str(case_id)
    file_MC_base_dir = '/Volumes/HD_SONY/CMAME/Final_MT/katoptron_CMAME_tests_plate_MC_MG_all_cases_2_ER_2/case_' + case_id
    #'/Volumes/HD_SONY/CMAME/Plate/MG/all/katoptron_CMAME_tests_plate_MC_MG_all_cases 2/case_' + case_id
    # try:
    speedup = compute_speedup(n_samples, ensemble_sizes, file_MC_base_dir,
                              querylines, per_iteration, quantiles,
                              use_waves_timers, use_teuchos_timers, True)

    plot_speedup(speedup, ensemble_sizes, np.arange(0, len(querylines)),
                 'case_' + case_id, querylines, per_iteration)
    plt.savefig('case_' + case_id + '.png', dpi=400)

    save_speedup(speedup, ensemble_sizes, querylines, 'case_' + case_id)

    R = compute_R(n_samples, ensemble_sizes, file_MC_base_dir, quantiles, True)
    save_R(R, 'case_' + case_id)
    # except:
    #    print '/Volumes/HD_SONY/CMAME/Plate/katoptron_CMAME_tests_plate_MC_case_' + case_id + '  has not all the files'


def main():
    import matplotlib.pyplot as plt

    n_samples = 64
    ensemble_sizes = [1, 8, 16, 32]
    quantiles = [0, 0.33, 0.5, 0.66, 1.]

    querylines = [
        'computeMatrices', 'Belos: Operation Op*x', 'Belos: Operation Prec*x',
        'Belos: DGKS[2]: Orthogonalization',
        'Belos: DGKS[2]: Ortho (Inner Product)',
        'Belos: DGKS[2]: Ortho (Norm)', 'Belos: DGKS[2]: Ortho (Update)',
        'total', 'write results', 'MueLu: Hierarchy: Solve (level=0)',
        'MueLu: Hierarchy: Solve (level=1)',
        'MueLu: Hierarchy: Solve : smoothing (level=0)',
        'MueLu: Hierarchy: Solve : prolongation (level=0)',
        'MueLu: Hierarchy: Solve : residual calculation (level=0)',
        'MueLu: Hierarchy: Solve : restriction (level=0)',
        'MueLu: SIMPLE: Apply: Update step - level 0',
        'MueLu: SIMPLE: Apply: Prediction step: Solve block 00 - level 0',
        'MueLu: SIMPLE: Apply: Prediction step: Compute RHS - level 0',
        'MueLu: SIMPLE: Apply: Correction step: Solve block 11 - level 0',
        'MueLu: SIMPLE: Apply: Correction step: Compute RHS - level 0'
    ]
    use_waves_timers = np.array([0, 7, 8], dtype=int)
    use_teuchos_timers = np.array(
        [1, 2, 3, 4, 5, 6, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19],
        dtype=int)
    per_iteration = [
        False, True, True, False, False, False, False, False, False, True,
        True, True, True, True, True, True, True, True, True, True
    ]

    for i in range(1, 7):
        speedup_of_one_case(i, n_samples, ensemble_sizes, quantiles,
                            querylines, use_waves_timers, use_teuchos_timers,
                            per_iteration)


if __name__ == "__main__":
    main()
