#ifndef KATOPTRON_SOURCE_H
#define KATOPTRON_SOURCE_H

#include "katoptron.h"
#include "wGroup.h"
#include <vector>
#include <string>

namespace katoptron
{

/**
 * @brief Class used to specify in Python the different volumetric heat sources.
 */
class KATOPTRON_API Source : public tbox::Group
{
public:
    std::string const &Source_name;
    std::vector<tbox::Node *> nodes;
    double value;

    Source(Problem &pbl,
           std::string const &name,
           std::string const &_Source_name,
           double v_T);
#ifndef SWIG
    virtual void write(std::ostream &out) const;
#endif
};

} // namespace katoptron

#endif //KATOPTRON_SOURCE_H
