/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WMEMTETRA4_H
#define WMEMTETRA4_H

#include "tbox.h"
#include "wMem.h"
#include "wTetra4.h"

#ifndef SWIG

namespace tbox
{

/**
 * @brief Precalculated values for Tetra4
 * @authors Romain Boman, Adrien Crovato
 */
class TBOX_API MemTetra4 : public Mem
{
    // Element type
    Tetra4 &e;

public:
    explicit MemTetra4(Tetra4 &_e, size_t _ngp);
    virtual ~MemTetra4() {}

    virtual void update(bool sameDim) override;
    virtual void updateGradients(bool sameDim) override;
};

} // namespace tbox

#endif

#endif //WMEMTETRA4_H
