/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WUNITTEST_H
#define WUNITTEST_H

#include "tbox.h"
#include "wObject.h"

namespace tbox
{

/**
 * @brief Tests for tbox
 * @authors Adrien Crovato
 */
class TBOX_API UnitTest : public fwk::wObject
{
    void error(std::string const &name, std::string const &computed, std::string const &expected);

public:
    UnitTest() : wObject() {}
    virtual ~UnitTest() {}

    void gmshIO(GmshExport *writer, GmshImport *reader);
    void mshDeform(MshDeform *mshDef, int d);
};

} // namespace tbox

#endif //WUNITTEST_H
